% Fichier de donnes pour :
%	Une simulation avec drive du champ magntique terrestre
%	Une orbite polaire  470 km
%	Une matrice d'inertie diagonale symtrique autour du tangage
%	Un d"pointage initial de 0.1 rd en tangage
%	Une vitesse angulaire de 0.1 rd/s en tangage,  l('injection


clear
clc

K_poinsot=1;              % Permet par la mise  0 de simuler un mouvement de poinsot, sans moment externe
                          % ce qui permet de vrifier une bonne partie de la simulation ( intgration)


% Gain de la matrice de gain pour la drive de B

% Constante de temps 

 tau=3000;

% Nombre de points du trac

 points_trace=10000;

% Ce fichier initialise la simulation regderiv.m ou regdesat.m oureg_derb.m

% Matrice d''inertie satellite

Ir=32e-3;It=36e-3;Il=32e-3;Irt=5.8e-5*0;Irl=3e-4*0;Itl=4e-3*0;

Asat=[Ir -Irt -Irl;
         -Irt It -Itl;
            -Irl -Itl Il];

% Caractristiques de l'orbite du satellite

altitude_orbite=222;		% altitude satellite en km
rayon_orbital=(6378+altitude_orbite)*1000;
vitesse_rotation=sqrt(39.86e13/rayon_orbital^3);
				% pulsation orbitale en rd/s
inclinaison=90*pi/180;

periode_orbitale=2*pi/vitesse_rotation;

%   **********  VALEURS INITIALES   ******

% Initialisation en vitesses (rd/)

v_roulis0=0;
v_tangage0=0.02;
v_lacet0=0;

% Initialisation en position (rd)

roulis0=0;
tangage0=0.1;
lacet0=0;

% ***************** DONNEES PERTURBATIONS********************

% ******************** Donnes annexes*************************

mom_magn_res=0.01; %  Moment magntique rsiduel en Am

alpha=sqrt(1/3);beta=sqrt(1/3);gamma=sqrt(1/3); % Direction unitaire /satellite du moment rsiduel

cpl_aero1=0;
cpl_aero2=-3.6e-8;% COUPLE AERODYNAMIQUE
cpl_aero3=0;




% cpl_magn_res1=1.5e-7;cpl_magn_res2=1.5e-7;cpl_magn_res3=1.5e-7;  % COUPLE MAGNETIQUE RESIDUEL

% **********************************************************************

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********
% Rotation absolue compose de la rotation par rapport au repre orbital
% et de la rotation  vitesse_rotation porte par Y

vp0=v_roulis0+v_lacet0*sin(tangage0)+...
    vitesse_rotation*sin(lacet0)*cos(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0)+...
    vitesse_rotation*(cos(lacet0)*cos(roulis0)+...
    sin(tangage0)*sin(roulis0)*sin(lacet0));

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0)+...
    vitesse_rotation*(-cos(lacet0)*sin(roulis0)+...
    sin(tangage0)*cos(roulis0)*sin(lacet0));
   

% ---- Calcul du quaternion initial connaissant les angles initiaux

% Matrice de passage P de la base fixe XYZ  la base satellite xyz
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% determinant=det(Pmat),% ************* Bien vrifi ***********

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);
end

if abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);
end

if abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);
end

if abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);
end

% Q=[qt00 qt10 qt20 qt30], %  ********* devrait avoir une norme 1

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

% normQ=norm(Q),% ******** vrifi *******

% energie=0.5*[vp0 vq0 vr0]*Asat*[vp0 vq0 vr0]',  %  ********  Energie devrait rester constante

etat_init=[vp0 vq0 vr0 Q(1) Q(2) Q(3) Q(4)]; 

% clear trac altitude qt00 qt10 qt20 qt30 vp0 vq0 vr0 Q Pmat

end








